<template>
  <SfModal class="sw-gs-il-modal" :visible="true" :overlay="true" :cross="false" >
    <template #modal-bar>
      <div v-if="instantListingModalType === instantListingTypes[0]" class="sw-gs-il-page-name-wrapper">
        <SwInput type="text"
                 v-model="pageName"
                 class="sw-gs-il-page-name-input"
                 name="instantListingName"
                 :placeholder="$t('Instant Listing Name')"/>
      </div>


      <div class="sw-gs-il-modal-close">
        <SfButton class="sf-button--pure sf-bar__icon" aria-label="close" type="button" @click="close()">
          <SfIcon icon="cross" size="20px"/>
        </SfButton>
      </div>
    </template>

      <div class="sw-gs-il-modal-content">

        <div class="sw-gs-il-modal-sidebar">
          <SfLoader class="sw-gs-il-loader is-sidebar"
                    :loading="instantListingSidebarLoading">
            <div class="sw-gs-il-modal-sidebar-inner">

              <div class="sw-gs-il-modal-search-wrapper">
                <SwGsIlSearchBar class="sw-gs-il-searchbar"/>
              </div>

              <div class="sw-gs-il-modal-sorting-wrapper">
                <div class="sw-gs-il-modal-sorting-headline">{{ $t('Sorting') }}</div>

                <SfSelect class="sw-gs-il-modal-sorting-select" v-model="currentSortingOrder" :size="getSortingOrders.length" :placeholder="$t('Select sorting')">
                  <SfSelectOption v-for="sortingOption in getSortingOrders"
                                  :key="sortingOption.key"
                                  :value="sortingOption.key">
                    {{ sortingOption.translated.label }}
                  </SfSelectOption>
                </SfSelect>
              </div>

              <div class="sw-gs-il-modal-filter-wrapper">

                <div class="sw-gs-il-modal-filter-headline">{{ $t('Filters') }}</div>

                <div class="filters">
                  <SwPluginSlot name="gs-il-filters">
                    <SwGsProductListingFilter
                        v-for="filter in ilProductFilter"
                        class="filters__filter"
                        :class="'is-' + filter.code + ' display-' + (filter.displayType ? filter.displayType : 'text')"
                        :filter="filter"
                        :current-filters="ilProductCurrentFilters"
                        :selected-filters="selectedFilters[filter.code]"
                        :selected-entity-filters="{}"
                        :key="filter.name"
                        :style="{ order: filter.position ? filter.position : 0 }"
                        @toggle-filter-value="toggleFilterValue"
                    />
                  </SwPluginSlot>
                </div>

              </div>

              <div class="filters__button-wrapper" v-if="ilProducts">
                <SwButton class="sf-button--full-width filters__button-clear"
                          @click="clearSelectedFilters()">
                  {{ $t("Clear all") }}
                </SwButton>
              </div>
            </div>
          </SfLoader>
        </div>

        <div class="sw-gs-il-modal-listing-wrapper">
          <div v-if="!instantListingLoading && instantListingModalType === instantListingTypes[0]"
            :class="{
              'sw-gs-il-modal-listing-actions': true,
              'sw-gs-prevent-click': instantListingSaving || (instantListingUpdated && instantListingUpdated.updated)
            }"
          >
            <a class="actions-btn add-btn" @click="addAllProducts">{{ $t('Add all') }} ({{allProductsCanBeAdded.length}})</a>
            <span>|</span>
            <a class="actions-btn remove-btn" @click="removeAddedProducts">{{ $t('Remove added') }} ({{allProductsCanBeRemoved.length}})</a>
          </div>
          <SfLoader class="sw-gs-il-loader is-listing"
            :loading="instantListingLoading">
            <div :class="{
              'sw-gs-il-modal-listing-inner': true,
              'sw-gs-prevent-click': instantListingSaving || (instantListingUpdated && instantListingUpdated.updated)
            }">
              <div v-if="ilProducts && ilProducts.length > 0"
                   class="sw-gs-il-modal-products-listing" >
                <div v-for="product in ilProducts" :key="product.id" class="sw-gs-il-modal-product-card-wrapper">
                  <SwPluginSlot name="gs-il-product-card" :slot-context="{product, toggleProduct}">
                    <SwGsLayerProductCard :product="product" @click="toggleProduct(product)"></SwGsLayerProductCard>
                    <SfLoader v-if="isGuidedProductLoading(product)" class="sw-gs-il-product-card-loader" :loading="true" />
                  </SwPluginSlot>
                  <SwCheckbox :selected="isProductSelected(product.id)" @change="toggleProduct(product)"/>
                </div>
              </div>
              <div v-else class="sw-gs-il-modal-products-listing is-empty">
                <span>{{ $t("No products found.") }}</span>
              </div>

              <SfPagination
                v-if="getTotalPagesCount > 1"
                class="cms-element-product-listing__pagination"
                :current="getCurrentPage"
                :total="getTotalPagesCount"
                :visible="5"
                pageParamName="p"
                @click="changePage">
                <template #prev>
                  <div class="cms-element-product-listing__pagination__number prev"
                       :class="{ 'prev-disabled': getCurrentPage === 1 }"
                       @click="changePage(getCurrentPage - 1)">
                    <SfIcon icon="arrow_left" size="xs"/>
                  </div>
                </template>
                <template #number="{ page }">
                  <div class="cms-element-product-listing__pagination__number"
                       :class="getCurrentPage === page ? 'current' : ''"
                       :style="{'font-weight': getCurrentPage === page ? 700 : 300,}"
                       @click="changePage(page)">
                    {{ page }}
                  </div>
                </template>
                <template #next>
                  <div class="cms-element-product-listing__pagination__number next"
                       :class="{ 'next-disabled': getCurrentPage === getTotalPagesCount }"
                       @click="changePage(getCurrentPage + 1)">
                    <SfIcon icon="arrow_right" size="xs"/>
                  </div>
                </template>
              </SfPagination>
            </div>
          </SfLoader>
        </div>

      </div>
  </SfModal>
</template>

<script lang="ts">
  import {
    SfModal,
    SfFilter,
    SfAccordion,
    SfSelect,
    SfComponentSelect,
    SfPagination,
    SfLoader,
    SfButton,
    SfIcon
  } from "@storefront-ui/vue";
  import SwGsAccordionItem from "../layer/SwGsAccordionItem.vue";
  import {useInstantListing, INSTANT_LISTING_TYPES} from "../../logic/composables/useInstantListing";
  import {useClearBodyScrollLock} from "../../logic/composables/useClearBodyScrollLock";
  import SwGsLayerProductCard from "../layer/SwGsLayerProductCard.vue";
  import SwCheckbox from "@/components/atoms/SwCheckbox.vue";
  import SwButton from "@/components/atoms/SwButton.vue";
  import SwInput from "@/components/atoms/SwInput.vue";
  import SwGsProductListingFilter from "../listing/SwGsProductListingFilter.vue";
  import {computed} from "@vue/composition-api";
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue";
  import SwGsIlSearchBar from "../instant-listing/SwGsIlSearchBar.vue";
  import {useIntercept} from '@shopware-pwa/composables';

  export default {
    name: "SwGsInstantListingModal",
    components: {
      SwGsLayerProductCard,
      SfModal,
      SfSelect,
      SfComponentSelect,
      SfFilter,
      SwGsAccordionItem,
      SfAccordion,
      SwCheckbox,
      SwInput,
      SwGsProductListingFilter,
      SwButton,
      SfPagination,
      SfLoader,
      SfButton,
      SfIcon,
      SwPluginSlot,
      SwGsIlSearchBar
    },

    setup() {
      const {
        loadAllProductData,
        ilProducts,
        ilProductFilter,
        ilProductCurrentFilters,
        toggleProduct,
        toggleFilterValue,
        selectedFilters,
        removeSelectedFilters,
        getSortingOrders,
        getCurrentSortingOrder,
        changeCurrentSortingOrder,
        changeCurrentPage,
        getTotal,
        getLimit,
        getCurrentPage,
        getTotalPagesCount,
        instantListingLoading,
        instantListingSaving,
        instantListingUpdated,
        isInstantListingModalOpen,
        instantListingModalType,
        guideProductsLoading,
        isProductSelected,
        allProductsCanBeAdded,
        allProductsCanBeRemoved,
        addAllProducts,
        removeAddedProducts,
        pageName,
        closeInstantListing
      } = useInstantListing();

      const {intercept} = useIntercept();
      intercept('usePresentation-reloadPage', () => {
        if (isInstantListingModalOpen.value) loadAllProductData();
      });

      useClearBodyScrollLock();

      loadAllProductData();

      const currentSortingOrder = computed({
        get: () => getCurrentSortingOrder.value,
        set: (order) => changeCurrentSortingOrder(order),
      })

      const changePage = async (pageNumber) => {
        if (pageNumber > getTotalPagesCount.value) {
          return
        }
        window.scrollTo(0, 0)
        await changeCurrentPage(pageNumber)
      }

      async function clearSelectedFilters() {
        removeSelectedFilters();
      }

      function close() {
        closeInstantListing();
      }

      function isGuidedProductLoading(product) {
        return guideProductsLoading.value.findIndex(x => x === product.id) >= 0;
      }

      return {
        ilProducts,
        ilProductFilter,
        ilProductCurrentFilters,
        toggleFilterValue,
        toggleProduct,
        isProductSelected,
        selectedFilters,
        removeSelectedFilters,
        clearSelectedFilters,
        getSortingOrders,
        getCurrentSortingOrder,
        changeCurrentSortingOrder,
        currentSortingOrder,
        getTotal,
        getTotalPagesCount,
        instantListingTypes: INSTANT_LISTING_TYPES,
        getLimit,
        getCurrentPage,
        instantListingModalType,
        isGuidedProductLoading,
        changePage,
        instantListingLoading,
        instantListingSaving,
        instantListingUpdated,
        instantListingSidebarLoading: computed(() => getSortingOrders.value?.length === 0 || ilProductFilter.value?.length === 0),
        isInstantListingModalOpen,
        close,
        pageName,
        allProductsCanBeAdded,
        allProductsCanBeRemoved,
        addAllProducts,
        removeAddedProducts
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";
  @import "../../assets/scss/components/_SwGsNavOverlay";
  @import "../../assets/scss/mixins/mediaQueries";

  .sw-gs-il-modal {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;

    .sw-gs-il-page-name-wrapper {
      @extend .sw-gs-nav-overlay;

      ::v-deep {
        .sf-input {
          min-width: 70%;
          input {
            padding: 0;
          }
        }
      }

      position: absolute;
      top: -75px;
      left: 0;
      width: calc(100% - 350px);
    }

    .sw-gs-il-modal-close {
      display: flex;
      justify-content: flex-end;

      ::v-deep .sf-button {
        .sf-icon {
          width: 20px;
        }
      }
    }

    .sw-gs-il-modal-sorting-headline,
    .sw-gs-il-modal-filter-headline {
      font-weight: 400;
      margin-bottom: 6px;
    }

    ::v-deep {
      .sf-modal__overlay {
        z-index: var(--modal-overlay-z-index);
      }

      .sf-modal__container {
        @extend .sw-gs-nav-overlay;
        width: calc(100% - var(--presentation-layer-width-maximized) - 65px);
        height: calc(100% - 105px);
        left: 40px;
        top: 90px;
        transform: none;
        max-height: none;
        z-index: var(--modal-container-z-index);

        .sf-button {
          margin-left: 0 !important;
        }
      }

      .sf-modal__content {
        display: flex;
        flex-direction: row;
        margin-top: -20px;
        border-radius: 5px;
        height: 100%;
        padding: 0;
      }
    }

    .sw-gs-il-modal-content {
      display: flex;
      width: 100%;
      height: 100%;
      max-height: 100%;

      .sw-gs-il-modal-sidebar {
        background-color: var(--c-light);
        width: 35%;
        overflow: hidden;

        @include for-desktop-big {
          width: 25%;
        }


        .sw-gs-il-modal-sidebar-inner {
          height: 100%;
        }

        .sw-gs-il-loader {
          ::v-deep .sf-loader__overlay {
            background: transparent;
          }
        }

        .sw-gs-il-modal-search-wrapper {
          padding: var(--spacer-xs) var(--spacer-xs) 0;
        }

        .sw-gs-il-modal-sorting-wrapper {
          padding: var(--spacer-xs) var(--spacer-xs) 0;

          .sw-gs-il-modal-sorting-select {
            padding-bottom: 0;
            padding-top: 0;
            height: auto;

            ::v-deep {
              .sf-select__label,
              .sf-select__error-message {
                display: none;
              }
            }
          }

        }

        .sw-gs-il-modal-filter-wrapper {
          width: auto;
          height: 100%;
          overflow-y: auto;
          padding: var(--spacer-xs) var(--spacer-xs) 0;
        }

      }

      .sw-gs-il-modal-listing-wrapper {
        display: flex;
        flex-direction: column;
        width: 65%;
        height: auto;
        padding: var(--spacer-base) var(--spacer-xs) var(--spacer-sm) var(--spacer-sm);
        overflow: hidden;

        .sw-gs-il-modal-listing-actions {
          display: flex;
          gap: 5px;
          justify-content: flex-end;
          align-items: center;
          .actions-btn {
            font-size: 14px;
            font-weight: 400;
            cursor: pointer;
          }
          .add-btn {
            color: var(--c-primary);
          }
          .remove-btn {
            color: var(--c-danger);
          }
        }

        @include for-desktop-big {
          width: 75%;
        }

        .sw-gs-il-loader.is-listing {
          width: 100%;
          height: 100%;
          overflow-y: auto;
        }

        .sw-gs-il-modal-products-listing {
          display: flex;
          flex-direction: row;
          flex-wrap: wrap;
          align-items: flex-start;

          .sw-gs-il-modal-product-card-wrapper {
            position: relative;
            width: calc(50% - var(--spacer-xs));
            margin-right: var(--spacer-xs);
            margin-bottom: var(--spacer-xs);

            @include for-desktop-big {
              width: calc(25% - var(--spacer-xs));
            }

            @include for-desktop-large {
              width: calc(20% - var(--spacer-xs));
            }

            &:hover {
              .sf-checkbox {
                display: block;
              }
            }


            .sw-gs-il-modal-product-card-inner {
              position: relative;
              max-width: var(--product-card-max-width, 248px);
              margin: 0 auto;
              .sw-gs-il-product-card-loader {
                position: absolute;
                z-index: 2;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                .sf-loader__overlay {
                  background: rgba(255,255,255, 0.5);
                }
              }
            }

            .sf-checkbox {
              position: absolute;
              top: var(--spacer-xs);
              right: var(--spacer-xs);
              z-index: var(--helper-lay-over-sibling-z-index);
              display: none;

              &.is-active {
                display: block;
              }

              .sf-checkbox__message {
                display: none;
              }

            }

          }

        }

        .cms-element-product-listing__pagination {
          display: flex;
          justify-content: center;

          .cms-element-product-listing__pagination__number {
            padding: 0 5px;
            cursor: pointer;
          }

        }

      }

    }

  }

  .filters {
    display: flex;
    flex-wrap: wrap;
    padding-bottom: 200px;
  }

  .filters__filter {
    padding: var(--spacer-sm) 0;
    width: 100%;

    &.is-rating {
      display: none; // do not show rating filter
    }

    &.is-shipping-free {
      display: flex;
      order: 1; // display single filters at the bottom
    }

  }

  .filters__button-wrapper {
    position: sticky;
    bottom: 0;
    padding: var(--spacer-xs);
    background-color: var(--c-light);
  }

  ::v-deep .sw-gs-layer-product-actions.is-overlay {

    .sw-gs-layer-product-actions-start {
      height: 60%;

      .sw-gs-layer-product-action {
        padding: var(--spacer-xs);

        .sw-gs-add-to-cart-btn {
          width: 25px;
          height: 25px;
          position: relative;
          bottom: inherit;
          right: inherit;
          transform: none;
          .sw-gs-icon {
            height: 15px;
            width: 15px;
          }
        }

      }

    }

    .sw-gs-layer-product-actions-end {
      height: 40%;
    }

  }

  .sw-gs-prevent-click {
    opacity: 0.5;
    pointer-events: none;
  }
</style>
